unit Work;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TfrmWorkCat = class(TForm)
    btnInsert: TButton;
    btnDelete: TButton;
    btnChange: TButton;
    btnExit: TButton;
    pbrDelete: TProgressBar;
    procedure btnInsertClick(Sender: TObject);
    procedure btnDeleteClick(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnChangeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmWorkCat: TfrmWorkCat;

implementation

uses BookMain, IDSetU;

{$R *.DFM}

procedure TfrmWorkCat.FormActivate(Sender: TObject);
begin
  pbrDelete.Visible := FALSE;
end;

procedure TfrmWorkCat.btnInsertClick(Sender: TObject);

var
  Value: string;

begin
  Value := InputBox('New Category','Input new Category','');
  if Value <> ''
  then frmBook.keyCat.InsertKey(Value);
  end;

procedure TfrmWorkCat.btnDeleteClick(Sender: TObject);

var
  found: shortstring;
  w,nk,LC: word;
  KillId,bid: longint;
  BBook: BookRec;
  CList: TIDSet;

begin
  with frmBook do begin
    found := '';
    if skyBooks.SelectOneKey(keyCat,
        'Choose category to delete',found)
    then begin
      if MessageDlg('Are you sure you want to delete '+found,
           mtConfirmation,[mbYes,mbNo],0) = mrYes
      then begin
        KillID := keyCat.GetKeyID(found);
        if KillID <> -1
        then begin
          nk := keyCat.GetRecIDCount(found);
          pbrDelete.Visible := TRUE;
          pbrDelete.Max := nk;
          pbrDelete.Position := 0;
          for w := 1 to nk do begin
            bid := keyCat.GetRecID(found,w);
            ffiBooks.Fetch(bid,@BBook);
            if BBook.Cats <> -1
            then begin
              LC := vfiCatList.GetBufSize(BBook.Cats);
              CList := TIDSet.Create;
              CList.Capacity := LC div 4;
              CList.Count := CList.Capacity;
              vfiCatList.Fetch(BBook.Cats,CList.SetPointer);
              CList.Delete(KillID);
              if CList.Count = 0
              then begin
                vfiCatList.Delete(BBook.Cats);
                idgCatList.Push(BBook.Cats);
                BBook.Cats := -1;
                ffiBooks.Restore(bid,@BBook);
                end
              else vfiCatList.Restore(BBook.Cats,CList.SetPointer,
                    CList.Count*4);
              CList.Free;
              end;
            pbrDelete.StepIt;
            end;
          pbrDelete.Visible := FALSE;
          keyCat.DeleteKey(found,FALSE); {FALSE to get rid of it}
          end;
        end;
      end;
    end;
  end;


procedure TfrmWorkCat.btnChangeClick(Sender: TObject);

var
  found: shortstring;
  Value: string;

begin
  with frmBook do begin
    found := '';
    if skyBooks.SelectOneKey(keyCat,
        'Choose category to change',found)
    then begin
      Value := InputBox('Replacing Category','Edit the Category',found);
      if Value <> found
      then begin
        if keyCat.ExistKey(Value)
        then ShowMessage('Sorry. The replacement category matches' +
           ' an existing one.')
        else keyCat.ChangeKey(found,Value);
        end;
      end;
    end;
  end;




procedure TfrmWorkCat.btnExitClick(Sender: TObject);
begin
  Close
end;


end.
